=== modified file 'src/com/goldencode/p2j/oo/net/http/DefaultHttpClientBuilder.java'
--- src/com/goldencode/p2j/oo/net/http/DefaultHttpClientBuilder.java	2021-02-21 16:25:50 +0000
+++ src/com/goldencode/p2j/oo/net/http/DefaultHttpClientBuilder.java	2021-10-13 13:43:50 +0000
@@ -10,6 +10,7 @@
 **          20201022 Add new protected method newClient (OE 12.2)
 ** 003 CA   20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
 **                   signature.
+**     ME   20210929 Fix return object on newClient.
 */
 
 /*
@@ -136,8 +137,9 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    protected object<? extends IhttpClient> newClient()
    {
-      return function(this, "NewClient", object.class, new Block((Body) () ->
-      {
+      object<? extends IhttpClient> client = TypeFactory.object(IhttpClient.class);
+
+      return function(this, "NewClient", object.class, new Block((Body) () -> {
          Assert.isTrue(hasOption(getPropClientName()));
          Assert.isTrue(hasOption(getPropClientVersion()));
 
@@ -146,9 +148,9 @@
 
          Assert.isType(clientType, ObjectOps.getLegacyClass(HttpClient.class));
 
-         object<? extends IhttpClient> client = (object<? extends IhttpClient>) ObjectOps
-                  .newInstance(clientType.ref().getType(), "III", getOptionStringValue(this.getPropClientName()),
-                           getOptionStringValue(this.getPropClientVersion()), buildLibrary());
+         client.assign(ObjectOps.newInstance(clientType.ref().getType(), "III",
+                  getOptionStringValue(this.getPropClientName()),
+                  getOptionStringValue(this.getPropClientVersion()), buildLibrary()));
 
          if (!client.isUnknown())
          {
@@ -188,8 +190,8 @@
             option.assign(ObjectOps.getLegacyName(ICookieJar.class));
             if (hasOption(option).booleanValue())
             {
-               client = ClientBuilder.decorateClient(
-                        ObjectOps.getLegacyClass(ISupportCookies.class), client);
+               client.assign(ClientBuilder
+                        .decorateClient(ObjectOps.getLegacyClass(ISupportCookies.class), client));
                ((ISupportCookies) client.ref()).setCookieJar(
                         (object<? extends ICookieJar>) getOptionObjectValue(option));
             }
@@ -198,8 +200,8 @@
             option.assign(ObjectOps.getLegacyName(ISupportProxy.class));
             if (hasOption(option).booleanValue())
             {
-               client = ClientBuilder
-                        .decorateClient(ObjectOps.getLegacyClass(ISupportProxy.class), client);
+               client.assign(ClientBuilder
+                        .decorateClient(ObjectOps.getLegacyClass(ISupportProxy.class), client));
                ((ISupportProxy) client.ref())
                         .setProxyUri((object<? extends Uri>) getOptionObjectValue(option));
             }

=== modified file 'src/com/goldencode/p2j/oo/net/http/DefaultResponseBuilder.java'
--- src/com/goldencode/p2j/oo/net/http/DefaultResponseBuilder.java	2021-02-21 16:25:50 +0000
+++ src/com/goldencode/p2j/oo/net/http/DefaultResponseBuilder.java	2021-10-13 13:43:50 +0000
@@ -10,6 +10,7 @@
 ** 003 ME   20201029 Implement as per OE12.2.
 ** 004 CA   20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
 **                   signature.
+**     ME 20210929   Fix return object on getResponse.
 */
 
 /*
@@ -76,7 +77,6 @@
 import com.goldencode.p2j.oo.core.Assert;
 import com.goldencode.p2j.oo.core.ISupportInitialize;
 import com.goldencode.p2j.oo.lang.LegacyClass;
-import com.goldencode.p2j.oo.lang._BaseObject_;
 import com.goldencode.p2j.util.*;
 import com.goldencode.p2j.util.BlockManager.Action;
 import com.goldencode.p2j.util.BlockManager.Condition;
@@ -108,6 +108,8 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL|RT_LVL_FULL)
    public object<? extends com.goldencode.p2j.oo.net.http.IhttpResponse> getResponse()
    {
+      object<? extends IhttpResponse> response = TypeFactory.object(IhttpResponse.class);
+      
       return function(DefaultResponseBuilder.class, this, "Response", object.class, new Block((Body) () -> 
       {
          object<? extends LegacyClass> responseCls = ObjectOps
@@ -117,7 +119,7 @@
          
          Assert.isType(responseType, responseCls);
 
-         object<? extends _BaseObject_> response = ObjectOps.newInstance(responseType.ref().getType());
+         response.assign(ObjectOps.newInstance(responseType.ref().getType()));
 
          if (response._isValid() && response.ref() instanceof ISupportInitialize)
             ((ISupportInitialize) response.ref()).initialize();

=== modified file 'src/com/goldencode/p2j/oo/net/http/HttpClient.java'
--- src/com/goldencode/p2j/oo/net/http/HttpClient.java	2022-01-20 16:27:48 +0000
+++ src/com/goldencode/p2j/oo/net/http/HttpClient.java	2022-02-11 15:26:27 +0000
@@ -15,6 +15,7 @@
 **     CA  20210221 Fixed parameters at the LegacySignature annotation.
 ** 007 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy signature.
 ** 008 ME  20210524 Added support for retries, destroy library and fix variable scope on execute.
+**     ME  20210929 Fix return object on instance method.
 **     CA  20220120 Do not used TypeFactory.object when the OO reference must not be tracked or registered.
 **                  Do not use TypeFactory.object for internal usages, use ObjectVar if the reference must 
 **                  be tracked.

=== modified file 'src/com/goldencode/p2j/oo/net/http/HttpHeader.java'
--- src/com/goldencode/p2j/oo/net/http/HttpHeader.java	2021-05-24 06:41:34 +0000
+++ src/com/goldencode/p2j/oo/net/http/HttpHeader.java	2021-10-13 13:43:50 +0000
@@ -316,7 +316,7 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL|RT_LVL_FULL)
    public static object<? extends HttpHeader> getNullHeader()
    {
-      return function(null, "NullHeader", object.class, new Block((Body) () -> 
+      return function(HttpHeader.class, "NullHeader", object.class, new Block((Body) () -> 
       {
          if (!NULL.get()._isValid())
          {

=== modified file 'src/com/goldencode/p2j/oo/net/http/ResponseBuilder.java'
--- src/com/goldencode/p2j/oo/net/http/ResponseBuilder.java	2021-05-24 06:41:34 +0000
+++ src/com/goldencode/p2j/oo/net/http/ResponseBuilder.java	2021-10-13 13:43:50 +0000
@@ -12,7 +12,8 @@
 ** 004 CA   20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
 **                   signature.
 **     ME   20210310 Add block 'referent' for static methods.
-** 005 ME  20210519 Fix registry lazy loading.
+** 005 ME   20210519 Fix registry lazy loading.
+**     ME   20210929 Fix return object on build.
 */
 
 /*
@@ -80,7 +81,6 @@
 import com.goldencode.p2j.oo.core.*;
 import com.goldencode.p2j.oo.core.util.ConfigBuilder;
 import com.goldencode.p2j.oo.lang.LegacyClass;
-import com.goldencode.p2j.oo.lang._BaseObject_;
 import com.goldencode.p2j.security.*;
 import com.goldencode.p2j.util.*;
 import com.goldencode.p2j.util.BlockManager.Action;
@@ -157,6 +157,8 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL|RT_LVL_FULL)
    public static object<? extends ResponseBuilder> build()
    {
+      object<? extends ResponseBuilder> builder = TypeFactory.object(ResponseBuilder.class);
+      
       return function(ResponseBuilder.class, "Build", object.class, new Block((Body) () -> 
       {
          object<? extends LegacyClass> builderCls = ObjectOps
@@ -166,8 +168,7 @@
          
          Assert.isType(builderType, builderCls);
 
-         object<? extends _BaseObject_> builder = ObjectOps
-                  .newInstance(builderType.ref().getType());
+         builder.assign(ObjectOps.newInstance(builderType.ref().getType()));
 
          if (builder._isValid() && builder.ref() instanceof ISupportInitialize)
             ((ISupportInitialize) builder.ref()).initialize();

=== modified file 'src/com/goldencode/p2j/oo/net/http/filter/payload/BinaryBodyWriter.java'
--- src/com/goldencode/p2j/oo/net/http/filter/payload/BinaryBodyWriter.java	2021-09-17 15:14:10 +0000
+++ src/com/goldencode/p2j/oo/net/http/filter/payload/BinaryBodyWriter.java	2022-02-11 15:26:27 +0000
@@ -111,7 +111,7 @@
    @Override
    public character getTransferEncoding()
    {
-      return function(null, "TransferEncoding", character.class, new Block((Body) () -> 
+      return function(this, "TransferEncoding", character.class, new Block((Body) () -> 
       {
          returnNormal(transferEncoding);
       }));

=== modified file 'src/com/goldencode/p2j/oo/net/http/filter/payload/BinaryEntityWriter.java'
--- src/com/goldencode/p2j/oo/net/http/filter/payload/BinaryEntityWriter.java	2021-02-21 16:25:50 +0000
+++ src/com/goldencode/p2j/oo/net/http/filter/payload/BinaryEntityWriter.java	2021-10-13 13:43:50 +0000
@@ -106,7 +106,7 @@
    @Override
    public character getTransferEncoding()
    {
-      return function(null, "TransferEncoding", character.class, new Block((Body) () -> 
+      return function(this, "TransferEncoding", character.class, new Block((Body) () -> 
       {
          returnNormal(transferEncoding);
       }));

=== modified file 'src/com/goldencode/p2j/oo/net/http/filter/payload/DefaultRequestFilter.java'
--- src/com/goldencode/p2j/oo/net/http/filter/payload/DefaultRequestFilter.java	2022-01-20 16:27:48 +0000
+++ src/com/goldencode/p2j/oo/net/http/filter/payload/DefaultRequestFilter.java	2022-02-11 15:26:27 +0000
@@ -9,6 +9,7 @@
 ** 002 MP  20210108 Adapt error message and do a cast for method access
 **     ME  20210204 Fix writeMessage and extractEntity methods.
 ** 003 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy signature.
+** 004 ME  20210929 Fixed return object on extractEntity.
 **     CA  20220120 Do not used TypeFactory.object when the OO reference must not be tracked or registered.
 **                  Do not use TypeFactory.object for internal usages, use ObjectVar if the reference must 
 **                  be tracked.
@@ -197,10 +198,11 @@
    protected object<? extends ByteBucket> extractEntity(final object<? extends IhttpRequest> _poRequest)
    {
       object<? extends IhttpRequest> poRequest = TypeFactory.initInput(_poRequest);
+      object<? extends ByteBucket> oMessageBody = TypeFactory.object(ByteBucket.class);
       
       return function(DefaultRequestFilter.class, this, "ExtractEntity", object.class, new Block((Body) () -> 
       {
-         object<? extends ByteBucket> oMessageBody = ByteBucket.instance();
+         oMessageBody.assign(ByteBucket.instance());
          
          object<? extends MessageWriterBuilder> oMWB = BodyWriterBuilder.build_1(poRequest);
          object<? extends MessageWriter> oBodyWriter = oMWB.ref().writeTo(oMessageBody).ref().getWriter();

=== modified file 'src/com/goldencode/p2j/oo/net/http/filter/payload/MessageWriter.java'
--- src/com/goldencode/p2j/oo/net/http/filter/payload/MessageWriter.java	2021-09-17 15:14:10 +0000
+++ src/com/goldencode/p2j/oo/net/http/filter/payload/MessageWriter.java	2022-02-11 15:26:27 +0000
@@ -120,7 +120,7 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL|RT_LVL_FULL)
    public object<? extends IlogWriter> getLogger()
    {
-      return function(null, "Logger", object.class, new Block((Body) () -> 
+      return function(this, "Logger", object.class, new Block((Body) () -> 
       {
          // TODO: 4Gl uses the LoggerBuilder, change when available
          if (logger.isUnknown())
@@ -160,7 +160,7 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL|RT_LVL_FULL)
    public object<? extends LegacyClass> getEntityType()
    {
-      return function(null, "EntityType", object.class, new Block((Body) () -> 
+      return function(this, "EntityType", object.class, new Block((Body) () -> 
       {
          returnNormal(entityType);
       }));
@@ -175,7 +175,7 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL|RT_LVL_FULL)
    public object<? extends BaseObject> getEntity()
    {
-      return function(null, "Entity", object.class, new Block((Body) () -> 
+      return function(this, "Entity", object.class, new Block((Body) () -> 
       {
          returnNormal(entity);
       }));

=== modified file 'src/com/goldencode/p2j/oo/net/http/filter/payload/MultipartBodyWriter.java'
--- src/com/goldencode/p2j/oo/net/http/filter/payload/MultipartBodyWriter.java	2022-01-20 16:27:48 +0000
+++ src/com/goldencode/p2j/oo/net/http/filter/payload/MultipartBodyWriter.java	2022-02-11 15:26:27 +0000
@@ -121,7 +121,7 @@
    @Override
    public character getBoundary()
    {
-      return function(null, "Boundary", character.class, new Block((Body) () -> 
+      return function(this, "Boundary", character.class, new Block((Body) () -> 
       {
          returnNormal(boundary);
       }));

=== modified file 'src/com/goldencode/p2j/oo/net/http/filter/payload/MultipartEntityWriter.java'
--- src/com/goldencode/p2j/oo/net/http/filter/payload/MultipartEntityWriter.java	2022-01-20 16:27:48 +0000
+++ src/com/goldencode/p2j/oo/net/http/filter/payload/MultipartEntityWriter.java	2022-02-11 15:26:27 +0000
@@ -122,7 +122,7 @@
    @Override
    public character getBoundary()
    {
-      return function(null, "Boundary", character.class, new Block((Body) () -> 
+      return function(this, "Boundary", character.class, new Block((Body) () -> 
       {
          returnNormal(boundary);
       }));

=== modified file 'src/com/goldencode/p2j/oo/net/http/filter/payload/StringEntityWriter.java'
--- src/com/goldencode/p2j/oo/net/http/filter/payload/StringEntityWriter.java	2021-09-17 15:14:10 +0000
+++ src/com/goldencode/p2j/oo/net/http/filter/payload/StringEntityWriter.java	2022-02-11 15:26:27 +0000
@@ -114,7 +114,7 @@
    @Override
    public character getEncoding()
    {
-      return function(null, "Encoding", character.class, new Block((Body) () -> 
+      return function(this, "Encoding", character.class, new Block((Body) () -> 
       {
          returnNormal(encoding);
       }));

=== modified file 'src/com/goldencode/p2j/oo/net/http/filter/payload/XmlBodyWriter.java'
--- src/com/goldencode/p2j/oo/net/http/filter/payload/XmlBodyWriter.java	2021-09-17 15:14:10 +0000
+++ src/com/goldencode/p2j/oo/net/http/filter/payload/XmlBodyWriter.java	2022-02-11 15:26:27 +0000
@@ -118,7 +118,7 @@
    @Override
    public character getEncoding()
    {
-      return function(null, "Encoding", character.class, new Block((Body) () -> 
+      return function(this, "Encoding", character.class, new Block((Body) () -> 
       {
          returnNormal(encoding);
       }));
@@ -255,7 +255,7 @@
          if ( !TextOps.begins(mContent, "<").booleanValue() )
          {
             String errMsg = "Character data does not appear to be XML; starts with \"" + 
-                     TextOps.substring(mContent, 1, 1).getValue() + "\"";                     
+                     TextOps.substring(mContent, 1, TextOps.indexOf(mContent, "<")).getValue() + "\"";                     
             undoThrow(AppError.newInstance(errMsg, 0));
          }
          

=== modified file 'src/com/goldencode/p2j/oo/net/http/filter/status/RedirectStatusFilter.java'
--- src/com/goldencode/p2j/oo/net/http/filter/status/RedirectStatusFilter.java	2021-09-17 15:14:10 +0000
+++ src/com/goldencode/p2j/oo/net/http/filter/status/RedirectStatusFilter.java	2022-02-11 15:26:27 +0000
@@ -312,7 +312,7 @@
    @Override
    public object<? extends IhttpMessage> getMessage()
    {
-      return function(null, "Message", object.class, new Block((Body) () -> 
+      return function(this, "Message", object.class, new Block((Body) () -> 
       {
          returnNormal(message);
       }));
@@ -343,7 +343,7 @@
    @Override
    public object<? extends IlogWriter> getLogger()
    {
-      return function(null, "Logger", object.class, new Block((Body) () -> 
+      return function(this, "Logger", object.class, new Block((Body) () -> 
       {
          returnNormal(logger);
       }));

=== modified file 'src/com/goldencode/p2j/oo/net/http/filter/writer/AuthenticationRequestWriterBuilder.java'
--- src/com/goldencode/p2j/oo/net/http/filter/writer/AuthenticationRequestWriterBuilder.java	2021-05-24 06:41:34 +0000
+++ src/com/goldencode/p2j/oo/net/http/filter/writer/AuthenticationRequestWriterBuilder.java	2021-10-13 13:43:50 +0000
@@ -14,6 +14,7 @@
 **                  signature.
 **     ME  20210310 Add block 'referent' for static methods.
 ** 006 ME  20210519 Fix registry lazy loading.
+**     ME  20210929 Fix return object on build.
 */
 
 /*
@@ -172,13 +173,13 @@
       object<? extends com.goldencode.p2j.oo.net.http.filter.auth.IauthFilterEventHandler> poListeners[] = TypeFactory
                .initInput(_poListeners);
 
+      object<? extends AuthenticationRequestFilter> writer = TypeFactory
+               .object(AuthenticationRequestFilter.class);
+      
       return function(AuthenticationRequestWriterBuilder.class, "Build", object.class, new Block((Body) () -> 
       {
          Assert.notNull(poRequest, new character("Request"));
 
-         object<? extends AuthenticationRequestFilter> writer = TypeFactory
-                  .object(AuthenticationRequestFilter.class);
-
          object<? extends LegacyClass> writerCls = getRegistry().ref()
                   .get(poRequest.ref().getAuthenticationMethod());
 

=== modified file 'src/com/goldencode/p2j/oo/net/http/filter/writer/BodyWriterBuilder.java'
--- src/com/goldencode/p2j/oo/net/http/filter/writer/BodyWriterBuilder.java	2022-01-20 16:27:48 +0000
+++ src/com/goldencode/p2j/oo/net/http/filter/writer/BodyWriterBuilder.java	2022-02-11 15:26:27 +0000
@@ -11,6 +11,7 @@
 ** 004 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy signature.
 **     ME  20210310 Add block 'referent' for static methods.
 **     VVT 20210917 Javadoc fixed. 
+**     ME  20210929 Fix return object on build.
 **     CA  20220120 Do not used TypeFactory.object when the OO reference must not be tracked or registered.
 **                  Do not use TypeFactory.object for internal usages, use ObjectVar if the reference must 
 **                  be tracked.

=== modified file 'src/com/goldencode/p2j/oo/net/http/filter/writer/SetHeaderMessageWriterBuilder.java'
--- src/com/goldencode/p2j/oo/net/http/filter/writer/SetHeaderMessageWriterBuilder.java	2022-01-20 16:27:48 +0000
+++ src/com/goldencode/p2j/oo/net/http/filter/writer/SetHeaderMessageWriterBuilder.java	2022-02-11 15:26:27 +0000
@@ -12,6 +12,7 @@
 ** 004 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy signature.
 ** 005 ME  20210519 Fix registry lazy loading.
 **     VVT 20210917 Javadoc fixed. 
+**     ME  20210929 Fix return object on build.
 **     CA  20220120 Do not used TypeFactory.object when the OO reference must not be tracked or registered.
 **                  Do not use TypeFactory.object for internal usages, use ObjectVar if the reference must 
 **                  be tracked.

=== modified file 'src/com/goldencode/p2j/oo/net/http/lib/ClientLibraryBuilder.java'
--- src/com/goldencode/p2j/oo/net/http/lib/ClientLibraryBuilder.java	2021-05-24 06:41:34 +0000
+++ src/com/goldencode/p2j/oo/net/http/lib/ClientLibraryBuilder.java	2021-10-13 13:43:50 +0000
@@ -17,6 +17,7 @@
 **                  signature.
 **     ME  20210301 Added class 'referent' for static methods.
 ** 008 ME  20210519 Fix registry lazy loading.
+**     ME  20210929 Fix return object on build.
 */
 
 /*
@@ -272,12 +273,14 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    public static object<? extends ClientLibraryBuilder> build()
    {
+      object<? extends ClientLibraryBuilder> builder = TypeFactory.object(ClientLibraryBuilder.class);
+      
       return function(ClientLibraryBuilder.class, "Build", object.class, new Block((Body) () ->
       {
          object<? extends LegacyClass> builderType = getRegistry().ref().get(new character(CLIENTLIBRARYBUILDER));
          Assert.isType(builderType, ObjectOps.getLegacyClass(ClientLibraryBuilder.class));
 
-         object<? extends _BaseObject_> builder = ObjectOps.newInstance(builderType.ref().getType());
+         builder.assign(ObjectOps.newInstance(builderType.ref().getType()));
 
          if (!builder.isUnknown() && builder.ref() instanceof ISupportInitialize)
             ((ISupportInitialize) builder.ref()).initialize();

=== modified file 'src/com/goldencode/p2j/oo/net/http/lib/sockets/LegacySocketLibrary.java'
--- src/com/goldencode/p2j/oo/net/http/lib/sockets/LegacySocketLibrary.java	2022-01-20 16:27:48 +0000
+++ src/com/goldencode/p2j/oo/net/http/lib/sockets/LegacySocketLibrary.java	2022-02-11 15:26:27 +0000
@@ -432,7 +432,7 @@
          }
 
          // negative port is breaking the connection params (-S -xxxx)
-         if (port.intValue() < 0)
+         if (port.isUnknown() || port.intValue() < 0)
          {
             ErrorManager.recordOrThrowError(new int[] { 1403, 5509, 5510 },
                      new String[] { "You have not supplied a parameter for argument -S",

=== modified file 'src/com/goldencode/p2j/oo/net/http/lib/sockets/LegacySocketLibraryBuilder.java'
--- src/com/goldencode/p2j/oo/net/http/lib/sockets/LegacySocketLibraryBuilder.java	2021-04-02 07:38:02 +0000
+++ src/com/goldencode/p2j/oo/net/http/lib/sockets/LegacySocketLibraryBuilder.java	2021-10-13 13:43:50 +0000
@@ -12,6 +12,7 @@
 ** 005 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
 **                  signature.
 **     ME  20210402 Added annotations, update support levels.
+**     ME  20210929 Fix return value on createClientSocket, buildSocketConnectionParams.
 */
 
 /*
@@ -172,9 +173,11 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    protected object<? extends ClientSocket> createClientSocket()
    {
+      object<? extends ClientSocket> clSocket = TypeFactory.object(ClientSocket.class);
+      
       return function(this, "CreateClientSocket", object.class, new Block((Body) () ->
       {
-         object<? extends ClientSocket> clSocket = ObjectOps.newInstance(ClientSocket.class);
+         clSocket.assign(ObjectOps.newInstance(ClientSocket.class));
          
          character clSTypName = new character(ObjectOps.getLegacyName(ClientSocket.class));
          character iLogWrtTypName = new character(ObjectOps.getLegacyName(IlogWriter.class));
@@ -208,11 +211,11 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    protected object<? extends ClientSocketConnectionParameters> buildSocketConnectionParams()
    {      
-      object<? extends ClientSocketConnectionParameters> clSocketConnParam = 
-               ObjectOps.newInstance(ClientSocketConnectionParameters.class);
+      object<? extends ClientSocketConnectionParameters> clSocketConnParam = TypeFactory.object(ClientSocketConnectionParameters.class);
       
       return function(this, "BuildSocketConnectionParams", object.class, new Block((Body) () ->
       {
+         clSocketConnParam.assign(ObjectOps.newInstance(ClientSocketConnectionParameters.class));
          character clSockConnParamTypName = new character("OpenEdge.Net.ServerConnection.ClientSocketConnectionParameters");
          
          if (hasOption(clSockConnParamTypName).booleanValue())

=== modified file 'src/com/goldencode/p2j/oo/reflect/AccessMode.java'
--- src/com/goldencode/p2j/oo/reflect/AccessMode.java	2021-02-21 16:25:50 +0000
+++ src/com/goldencode/p2j/oo/reflect/AccessMode.java	2021-10-22 06:53:10 +0000
@@ -12,6 +12,7 @@
 ** 004 ME  20200423 Drop using context local variables for enums, class not registered.
 ** 005 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
 **                  signature.
+** 006 ME  20211022 Added package protected/private enum members.
 */
 
 /*
@@ -93,6 +94,12 @@
    @LegacySignature(type = Type.VARIABLE, name = "Private")
    public static final object<? extends AccessMode> private_;
    
+   @LegacySignature(type = Type.VARIABLE, name = "Package-Protected")
+   public static final object<? extends AccessMode> packageProtected;
+   
+   @LegacySignature(type = Type.VARIABLE, name = "Package-Private")
+   public static final object<? extends AccessMode> packagePrivate;
+   
    static
    {
       registerEnum(AccessMode.class, AccessMode::new, "Progress.Reflect.AccessMode");
@@ -100,6 +107,8 @@
       public_ = createEnum(AccessMode.class, "Public");
       protected_ = createEnum(AccessMode.class, "Protected");
       private_ = createEnum(AccessMode.class, "Private");
+      packageProtected = createEnum(AccessMode.class, "Package-Protected");
+      packagePrivate = createEnum(AccessMode.class, "Package-Private");
    }
    
    private AccessMode(String name, long value)

=== modified file 'src/com/goldencode/p2j/oo/reflect/Flags.java'
--- src/com/goldencode/p2j/oo/reflect/Flags.java	2021-02-21 16:25:50 +0000
+++ src/com/goldencode/p2j/oo/reflect/Flags.java	2021-10-22 06:53:10 +0000
@@ -10,6 +10,7 @@
 **     GES 20200521 Changes to match final legacy enum approach.
 ** 003 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
 **                  signature.
+** 004 ME  20211022 Added package protected/private enum members.
 */
 
 /*
@@ -95,6 +96,12 @@
 
    public static final object<? extends Flags> declaredOnly;
    
+   @LegacySignature(type = Type.VARIABLE, name = "Package-Protected")
+   public static final object<? extends Flags> packageProtected;
+   
+   @LegacySignature(type = Type.VARIABLE, name = "Package-Private")
+   public static final object<? extends Flags> packagePrivate;
+   
    static {
       registerEnum(Flags.class, Flags::new, "Progress.Reflect.Flags");
       
@@ -104,6 +111,8 @@
       static_ = createEnum(Flags.class, "Static");
       instance = createEnum(Flags.class, "Instance");
       declaredOnly = createEnum(Flags.class, "DeclaredOnly");
+      packageProtected = createEnum(Flags.class, "Package-Protected");
+      packagePrivate = createEnum(Flags.class, "Package-Private");
    }
    
    private Flags(String name, long value)

=== modified file 'src/com/goldencode/p2j/oo/reflect/Legacy4GLMethod.java'
--- src/com/goldencode/p2j/oo/reflect/Legacy4GLMethod.java	2021-02-21 16:25:50 +0000
+++ src/com/goldencode/p2j/oo/reflect/Legacy4GLMethod.java	2021-10-28 07:59:30 +0000
@@ -10,6 +10,7 @@
 ** 002 CA  20191024 Added method support levels and updated the class support level.
 ** 003 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
 **                  signature.
+**     ME  20211028 Added 'POLY' return data type for invoke. 
 */
 
 /*
@@ -69,7 +70,6 @@
 
 import com.goldencode.p2j.util.*;
 import com.goldencode.p2j.oo.lang.*;
-import com.goldencode.p2j.oo.reflect.Parameter;
 
 import static com.goldencode.p2j.util.BlockManager.*;
 import static com.goldencode.p2j.report.ReportConstants.*;
@@ -253,7 +253,7 @@
       }));
    }
 
-   @LegacySignature(returns = "OBJECT", type = Type.METHOD, name = "Invoke", qualified = "progress.lang.object", parameters = 
+   @LegacySignature(type = Type.METHOD, name = "Invoke", returns = "BDT", parameters = 
    {
       @LegacyParameter(name = "params", type = "OBJECT", qualified = "progress.lang.parameterlist", mode = "INPUT")
    })
@@ -263,20 +263,20 @@
      end.
    */   
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL|RT_LVL_STUB)
-   public object<? extends _BaseObject_> invoke(final object<? extends ParameterList> _params)
+   public Object invoke(final object<? extends ParameterList> _params)
    {
       object<? extends ParameterList> params = TypeFactory.initInput(_params);
       
       return function(this, "Invoke", object.class, new Block());
    }
 
-   @LegacySignature(returns = "OBJECT", type = Type.METHOD, name = "Invoke", qualified = "progress.lang.object", parameters = 
+   @LegacySignature(type = Type.METHOD, name = "Invoke", returns = "BDT", parameters = 
    {
       @LegacyParameter(name = "instance", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT"),
       @LegacyParameter(name = "params", type = "OBJECT", qualified = "progress.lang.parameterlist", mode = "INPUT")
    })
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL|RT_LVL_STUB)
-   public object<? extends _BaseObject_> invoke(final object<? extends _BaseObject_> _instance, final object<? extends ParameterList> _params)
+   public Object invoke(final object<? extends _BaseObject_> _instance, final object<? extends ParameterList> _params)
    {
       object<? extends _BaseObject_> instance = TypeFactory.initInput(_instance);
       object<? extends ParameterList> params = TypeFactory.initInput(_params);

=== modified file 'src/com/goldencode/p2j/oo/reflect/LegacyConstructor.java'
--- src/com/goldencode/p2j/oo/reflect/LegacyConstructor.java	2021-02-21 16:25:50 +0000
+++ src/com/goldencode/p2j/oo/reflect/LegacyConstructor.java	2021-10-28 07:59:30 +0000
@@ -8,6 +8,7 @@
 ** 001 ME  20200421 First version, stubs taken by converting the skeleton using FWD.
 ** 002 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
 **                  signature.
+**     ME  20211028 Added 'POLY' return data type for invoke.
 */
 
 /*
@@ -158,10 +159,10 @@
       }));
    }
 
-   @LegacySignature(returns = "OBJECT", type = Type.METHOD, name = "Invoke", qualified = "progress.lang.object", parameters = {
+   @LegacySignature(type = Type.METHOD, name = "Invoke", returns = "BDT", parameters = {
             @LegacyParameter(name = "params", type = "OBJECT", qualified = "progress.lang.parameterlist", mode = "INPUT") })
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_STUB)
-   public object<? extends _BaseObject_> invoke(final object<? extends ParameterList> _params)
+   public Object invoke(final object<? extends ParameterList> _params)
    {
       object<? extends ParameterList> params = TypeFactory.initInput(_params);
 

